/**********************************************************
* @ File name -> sys.c
* @ Version   -> V1.0
* @ Date      -> 12-26-2013
* @ Brief     -> ϵͳصĺ
**********************************************************/

#include "sys.h"

/**********************************************************
*  ---> ȡоƬ
* ڲ ---> *STMCapaַʾ
* ֵ ---> ʮƣ
* ˵ ---> none
**********************************************************/
void STM32_Flash_Capacity(uint8_t *STMCapa)
{
	uint16_t capa;

	capa = *((uint16_t*)0x1ffff7e0);	//ȡĴ16λЧ

	capa = ((capa >> 12) * 4096 + ((capa >> 8) & 0x0f) * 256 + ((capa >> 4) & 0x0f) * 16 + (capa & 0x0f));	//תʮ

	STMCapa[0] = 0x4d;	//M
	STMCapa[1] = 0x43;	//C
	STMCapa[2] = 0x55;	//U
	STMCapa[3] = 0x43;	//C
	STMCapa[4] = 0x61;	//a
	STMCapa[5] = 0x70;	//p
	STMCapa[6] = 0x3a;	//:

	if((capa / 1000) != 0)	STMCapa[7] = capa / 1000 + 48;	//ǧλΪ0ʱʾ
	else	STMCapa[7] = 0x20;

	STMCapa[8] = capa % 1000 / 100 + 48;	//λ
	STMCapa[9] = capa % 100 /10 + 48;		//ʮλ
	STMCapa[10] = capa % 10 + 48;			//λ
	STMCapa[11] = 0x4b;	//K
	STMCapa[12] = 0x62;	//b
}
/**********************************************************
*  ---> ȡCPUID
* ڲ ---> none
* ֵ ---> CPUIDʮƣ
* ˵ ---> none
**********************************************************/
void STM32_CPUID(uint8_t *IDbuff)
{
	uint32_t CPUID;
	CPUID = *((uint32_t*)0xe000ed00);
	sprintf((char*)IDbuff, "CPU ID:%08lX", CPUID);
}
/**********************************************************
*  ---> ƫƵַ
* ڲ ---> NVIC_VectTabַ
*              Offsetƫ
* ֵ ---> ʮƣ
* ˵ ---> none
**********************************************************/
void MY_NVIC_SetVectorTable(uint32_t NVIC_VectTab,uint32_t Offset)
{
	SCB->VTOR = NVIC_VectTab | (Offset & (uint32_t)0x1fffff80);//NVICƫƼĴ
	//ڱʶCODERAM
}
/**********************************************************
*  ---> жϷ
* ڲ ---> NVIC_PriorityGroup: жϷ
* ֵ ---> none
* ˵ ---> 0 ~ 4飬5
**********************************************************/
void MY_NVIC_PriorityGroup_Config(uint32_t NVIC_PriorityGroup)
{
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup);	//жϷ

//	uint32_t temp,temp1;
//
//	temp1 = (~NVIC_PriorityGroup) & 0x00000007;//ȡλ
//	temp1 <<= 8;
//	temp = SCB->AIRCR;  //ȡǰ
//	temp &= 0x0000f8ff; //ǰ
//	temp |= 0x05fa0000; //дԿ
//	temp |= temp1;
//	SCB->AIRCR = temp;  //÷
}
/**********************************************************
*  ---> жϷȼ
* ڲ ---> NVIC_PreemptionPriorityȼ
*               NVIC_SubpriorityӦȼ
*               NVIC_Channelжϱ
*               NVIC_Group: жϷ
* ֵ ---> none
* ˵ ---> 1黮:
*                  00λռȼ4λӦȼ
*                  11λռȼ3λӦȼ
*                  22λռȼ2λӦȼ
*                  33λռȼ1λӦȼ
*                  44λռȼ0λӦȼ
*               2ȼӦȼԭֵԽСȼԽ
**********************************************************/
void MY_NVIC_Init(uint8_t NVIC_PreemptionPriority,uint8_t NVIC_Subpriority,uint8_t NVIC_Channel,uint32_t NVIC_Group)
{
	NVIC_InitTypeDef NVIC_InitStructure;

	MY_NVIC_PriorityGroup_Config(NVIC_Group);	//жϷ

	NVIC_InitStructure.NVIC_IRQChannel = NVIC_Channel;								//жͨ
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = NVIC_PreemptionPriority;	//ȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = NVIC_Subpriority;				//Ӧȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;									//ʹж

	NVIC_Init(&NVIC_InitStructure);	//ʼж

//	uint32_t temp;
//	uint8_t IPRADDR=NVIC_Channel/4;  //ÿֻܴ4,õַ
//	uint8_t IPROFFSET=NVIC_Channel%4;//ڵƫ
//
//	IPROFFSET = IPROFFSET*8 + 4;    //õƫƵȷλ
//
//	MY_NVIC_PriorityGroup_Config(NVIC_Group);//÷
//
//	temp  = NVIC_PreemptionPriority << (4 - NVIC_Group);	//ȼ
//	temp |= NVIC_Subpriority & (0x0f >> NVIC_Group);	//Ӧȼ
//	temp &= 0xf;//ȡλ

//	if(NVIC_Channel < 32)	NVIC->ISER[0] |= 1 << NVIC_Channel;//ʹжλ(ҪĻ,෴OK)
//	else	NVIC->ISER[1]| |= 1 << (NVIC_Channel - 32);
//
//	NVIC->IPR[IPRADDR] |= temp << IPROFFSET;//Ӧȼȼ
}
/**********************************************************
*  ---> THUMBָֻ֧
* ڲ ---> none
* ֵ ---> none
* ˵ ---> ·ʵִлָWFI
**********************************************************/
void WFI_SET(void)
{
	asm("WFI");
}
/**********************************************************
*  ---> ʱӼĴλ
* ڲ ---> none
* ֵ ---> none
* ˵ ---> ִ踴λ!𴮿ڲ
**********************************************************/
void MY_RCC_DeInit(void)
{
	RCC->APB1RSTR = 0x00000000;	//λ
	RCC->APB2RSTR = 0x00000000;

  	RCC->AHBENR   = 0x00000014;	//˯ģʽSRAMʱʹ.ر.
  	RCC->APB2ENR  = 0x00000000;	//ʱӹر.
  	RCC->APB1ENR  = 0x00000000;
	RCC->CR      |= 0x00000001;	//ʹڲʱHSION
	RCC->CFGR    &= 0xf8ff0000;	//λSW[1:0],HPRE[3:0],PPRE1[2:0],PPRE2[2:0],ADCPRE[1:0],MCO[2:0]
	RCC->CR      &= 0xfef6ffff;	//λHSEON,CSSON,PLLON
	RCC->CR      &= 0xfffbffff;	//λHSEBYP
	RCC->CFGR    &= 0xff80ffff;	//λPLLSRC, PLLXTPRE, PLLMUL[3:0] and USBPRE
	RCC->CIR      = 0x00000000;	//رж

	//
#ifdef  VECT_TAB_RAM
	MY_NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0);
#else
	MY_NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
#endif
}
/**********************************************************
*  ---> оƬģʽ
* ڲ ---> none
* ֵ ---> none
* ˵ ---> WKUPŻѣPA.0
**********************************************************/
void SYS_Standby(void)
{
	SCB->SCR |= 1 << 2;			//ʹsleep deepSYS->CTRL
	RCC->APB1ENR |= 1 << 28;	//Դӿʱӿ
	PWR->CSR |= 1 << 8;			//WKUPڻ
	PWR->CR |= 1 << 2;			//WAKE-UP־
	PWR->CR |= 1 << 1;			//PDDSλ˯
	WFI_SET();					//ִWFIָ
}
/**********************************************************
*  ---> ϵͳλ
* ڲ ---> none
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void SYS_SoftReset(void)
{
	SCB->AIRCR = 0x05fa0000 | 0x00000004;
}
/**********************************************************
*  ---> JTAGģʽ
* ڲ ---> modeģʽ
*                    000JTAG-DP + SW-DPλ״̬
*                    001JTAG-DP + SW-DPJNTRSTţͷJRSTţ
*                    010JTAG-DPӿڽֹSW-DPӿ
*                    100JTAG-DPӿںSW-DPӿڶֹ
*                    xxxֵֹ
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void STM_JTAG_Set(uint32_t mode)
{
	RCC->APB2ENR |= 1 << 0;		//ʹܸʱ
	AFIO->MAPR &= 0xf8ffffff;	//SWJ_CFG[2:0]λ26:24
	AFIO->MAPR |= (mode << 24);	//JTAGģʽ
}
/**********************************************************
*  ---> ϵͳʱӳʼ
* ڲ ---> pllƵȡֵΧ2 ~ 16
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void STM_Clock_Init(uint8_t pll)
{
	uint8_t tmp = 0;

	MY_RCC_DeInit();	//λҽⲿжϺʱȫر

	RCC->CR |= 0x00010000;  //ⲿʱʹHSEON

	while(!(RCC->CR >> 17));//ȴⲿʱӾ

	RCC->CFGR = 0X00000400; //APB1=DIV2;APB2=DIV1;AHB=DIV1;
	pll -= 2;//2λ
	RCC->CFGR |= pll << 18;   //PLLֵ 2~16
	RCC->CFGR |= 1 << 16;	  //PLLSRC ON
	FLASH->ACR |= 0x32;	  //FLASH 2ʱ

	RCC->CR |= 0x01000000;  //PLLON

	while(!(RCC->CR >> 25));//ȴPLL

	RCC->CFGR |= 0x00000002;//PLLΪϵͳʱӣܿPLLΪ趨PLLʱPLLλڹر״̬½

	while(tmp != 0x02)     //ȴPLLΪϵͳʱóɹ
	{
		tmp  = RCC->CFGR >> 2;
		tmp &= 0x03;
	}
}
/**********************************************************
*  ---> BCDתΪHEX
* ڲ ---> BCD_DataҪתBCD
* ֵ ---> HEX
* ˵ ---> none
**********************************************************/
uint8_t BCD_to_HEX(uint8_t BCD_Data)
{
	return((BCD_Data / 10) << 4 | (BCD_Data % 10));
}
/**********************************************************
*  ---> HEXתΪBCD
* ڲ ---> HEX_DataҪתBCD
* ֵ ---> BCD
* ˵ ---> none
**********************************************************/
uint8_t HEX_to_BCD(uint8_t HEX_Data)
{
	return((HEX_Data >> 4) * 10 + (HEX_Data & 0x0f));
}
/**********************************************************
*  ---> 10תΪ16
* ڲ ---> DX_DataҪת10
* ֵ ---> 16
* ˵ ---> none
**********************************************************/
uint16_t DX_to_HX(uint16_t DX_Data)
{
	return(((DX_Data/1000)<<12) | ((DX_Data%1000/100)<<8) | ((DX_Data%100/10)<<4) | (DX_Data%10));
}
/**********************************************************
*  ---> 16תΪ10
* ڲ ---> HX_DataҪת16
* ֵ ---> 10
* ˵ ---> none
**********************************************************/
uint16_t HX_to_DX(uint16_t HX_Data)
{
	return((HX_Data>>12)*1000+((HX_Data&0x0f00)>>8)*100+((HX_Data&0x00f0)>>4)*10+(HX_Data&0x000f));
}

///**********************************************************
//*  ---> ʼб
//* ڲ ---> *LISTбָ
//* ֵ ---> none
//* ˵ ---> none
//**********************************************************/
//void Sqlist_Init(Sqlist *LIST)
//{
//	LIST->elem = (uint16_t*)malloc(MaxSize * sizeof(ElemType));
//	//һΪMaxSize * sizeof(ElemType)Сڴռ
//	if(!LIST->elem)	return;	//ûбֱ˳
//	//ɹ
//	LIST->length = 0;	//бû
//	LIST->listsize = MaxSize;	//ݱռڴСΪMaxSizesizeof(ElemType)Ϊλ
//}
///**********************************************************
//*  ---> λб
//* ڲ ---> none
//* ֵ ---> none
//* ˵ ---> none
//**********************************************************/
//void Sqlist_DeInit(void)
//{
//	Sqlist *list;
//
//	list->elem = 0;	//׵ַ
//	list->length = 0;	//
//	list->listsize = 0;	//бСΪ0
//}
///**********************************************************
//*  ---> һ̬бһԪ
//* ڲ ---> *Lбָ
//*               iбеiλòԪ
//*               itemڵiλԪ
//* ֵ ---> none
//* ˵ ---> none
//**********************************************************/
//void InsertElem(Sqlist *L,uint16_t i,ElemType item)
//{	/* ˳б*LĵiλòԪitem */
//	ElemType *base, *insertPtr, *p;
//
//	if(i < 1 || i > L->length + 1)	return;	//Ƿ
//	if(L->length >= L->listsize)	//бһλòԪ
//	{	//׷ڴռ
//		base = (ElemType*)realloc(L->elem,(L->listsize + 10) * sizeof(ElemType));
//		L->elem = base;	//ڴַ
//		L->listsize = L->listsize + 100;	//洢ռ100Ԫ
//	}
//	insertPtr = &(L->Elem[i - 1]);	//insertPtrΪλ
//	for(p = &(L->elem[L->length - 1]);p >= insertPtr;p--)
//		*(p + 1) = *p;	//i - 1ԺԪ˳һԪλ
//	*insertPtr = item;	//ڵiλϲԪitem
//	L->length++;	//1
//}

