#include "delay.h"
#include "sys.h"

//////////////////////////////////////////////////////////////////////////////////
//Ⱥ
//:2015/6/17
//:2015/6/22
//汾V1.0
//ȨУؾ
//Copyright(C) ާܿƼ޹˾
//********************************************************************************
/**********************************************************
* @ File name -> delay.c
* @ Version   -> V1.0.1
* @ Date      -> 02-26-2014
* @ Brief     -> ϵͳʱصĺ

* @ ϸ˵οCortex-M3Ȩָ()133 ~ 134ҳ 8 SysTickʱ

 V1.0.1
* @ Revise    -> һʱ㷽
**********************************************************/

/*
* @ SysTickʱ ؿƼĴ˵

@ 1SysTickƼ״̬Ĵַ0xE000_E010λֵΪ0

	bit16 COUNTFLAG(R  -> ϴζȡĴSysTickѾ0λΪ1ȡλλԶ
	bit2  CLKSOURCE(R/W) -> 0=ⲿʱԴ(STCLK)1=ںʱ(FCLK)
	bit1  TICKINT(R/W)   -> 1=SysTick0ʱSysTick쳣,0=0ʱ޶
	bit0  ENABLE(R/W)    -> SysTickʱʹλ

@ 2SysTickװֵĴַ0xE000_E014λֵΪ0

	[23:0] RELOAD(R/W) -> ʱװصֵ

@ 3SysTickǰֵĴַ0xE000_E018 λֵΪ0

	[23:0] CURRENT(R/Wc) -> ȡʱصǰֵдʹ֮㣬ͬʱSysTick Ƽ״̬ĴеCOUNTFLAG־

@ 4SysTickУ׼ֵĴַ0xE000_E01Cλֵ: bit31δ֪bit30δ֪[23:0]Ϊ0

	bit32 NOREF(R)    -> 1=ûⲿοʱӣSTCLKã0=ⲿοʱӿ
	bit30 SKEW(R)     -> 1=У׼ֵ׼ȷ10ms0=У׼ֵ׼ȷ10ms
	[23:0] TENMS(R/W) -> 10msʱڵĸоƬӦͨCortex\M3źṩֵֵ㣬ʾ޷ʹУ׼

*/

#include "delay.h"

/**********************************************************
           ʹǶʽϵͳʱʼ
**********************************************************/

#if _SYSTEM_SUPPORT_ROTS	//֧ʵʱǶʽϵͳ
	#include ""	//ӲϵͳҪͷļ

/**********************************************************
*  ---> SysTickʱʼ
* ڲ ---> SYSCLKϵͳߵƵʡλMHz
*               TICKINT_CNTжʱλmsݲϵͳʱ
* ֵ ---> none
* ˵ ---> ҪǳʼSysTickĴ
**********************************************************/
void OS_Heart_Init(uint8_t SYSCLK, uint8_t TICKINT_CNT)
{
	uint32_t RELOAD;	//0ʱװֵЧλ0 ~ 23

	/* SysTickʱʱӷƵȷװֵ */
	/* 8Ƶʱ80000001Ƶʱ1000000 */
	RELOAD = SystemCoreClock / 8000000;	//ÿӵļλHz
	RELOAD *= 1000000 / TICKINT_CNT;	//ݲϵͳʱʱ䣬λKHz
	                                    //RELOADΪ24λֵΪ:16777216

	SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);	//ѡⲿʱHCLK/8
	SysTick->CTRL |= SysTick_CTRL_TICKINT_Msk;	//SysTickʱж
	SysTick->LOAD = RELOAD;	//ֵÿ1/TICKINT_CNTжһ
	SysTick->CTRL |= SysTick_CTRL_ENABLE_Msk;      //ʼ
}
/**********************************************************
*  ---> SysTickʱжϷ
* ڲ ---> none
* ֵ ---> none
* ˵ ---> ڴ˱дˣstm32f10x_it.cоͲҪдstm32f10x_it.cоҪд
**********************************************************/
void SysTick_Handler(void)
{
	/* дSysTickʱжϲصAPI */
}

#endif

/**********************************************************
              Ƕʽϵͳ
**********************************************************/

//=========================================================
#if _USER_SysTick	//ʹSysTickʱʱ
//=========================================================

/**********************************************************
                     
**********************************************************/

static uint8_t  fac_us=0;	//usʱ
static uint16_t fac_ms=0;	//msʱ

/**********************************************************
*  ---> ʼʱ
* ڲ ---> SYSCLKϵͳߵƵʡλM
* ֵ ---> none
* ˵ ---> ҪǳʼSysTickĴ
**********************************************************/
void delay_init(uint8_t SYSCLK)
{
	SysTick->CTRL &= 0xfffffffb;	//bit2գѡⲿʱHCLK/8ֹͣ
	fac_us = SYSCLK/8;	//ϵͳʱӵ1/8
	fac_ms = (uint16_t)fac_us*1000;	//msҪSysTickʱ
}
/**********************************************************
*  ---> ʱnus
* ڲ ---> nusҪʱus
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void delay_us(uint32_t nus)
{
	uint32_t temp;

	SysTick->LOAD = nus*fac_us; //ʱ
	SysTick->VAL = 0x00;        //ռ
	SysTick->CTRL |= SysTick_CTRL_ENABLE_Msk;      //ʼ
	do
	{
		temp = SysTick->CTRL;
	}
	while(temp&0x01&&!(temp&(1<<16)));	//ȴʱ䵽
	SysTick->CTRL &= ~SysTick_CTRL_ENABLE_Msk;	//رռ
	SysTick->VAL = 0x00;	//ռ
}
/**********************************************************
*  ---> ʱnms
* ڲ ---> nusҪʱus
* ֵ ---> none
* ˵ ---> SysTick->LOADΪ24λĴ,,ʱΪ:
*               nms <= 0xffffff*8*1000/SYSCLK
*               SYSCLKλΪHz,nmsλΪms
*               עnmsķΧ 0 ~ 1864(72M)
**********************************************************/
void delay_ms(uint16_t nms)
{
	uint32_t temp;

	SysTick->LOAD = (uint32_t)nms*fac_ms;	//ʱ(SysTick->LOADΪ24bit)
	SysTick->VAL = 0x00;           //ռ
	SysTick->CTRL |= SysTick_CTRL_ENABLE_Msk;      //ʼ
	do
	{
		temp = SysTick->CTRL;
	}
	while(temp&0x01&&!(temp&(1<<16)));	//ȴʱ䵽
	SysTick->CTRL &= ~SysTick_CTRL_ENABLE_Msk;	//رռ
	SysTick->VAL = 0x00;	//ռ
}

//=========================================================
#else	//ʹԴʱ
//=========================================================

/**********************************************************
                     
**********************************************************/

static uint32_t CPU_CLK;	//ڱcpuƵ

/**********************************************************
*  ---> ʼʱ
* ڲ ---> SYSCLKϵͳߵƵʡλMHz
* ֵ ---> none
* ˵ ---> ҪCortex-M3ں˶ϵͳʱӼԪ
*               ϸCortex-M3Ȩָ()216ҳ a)  ʱڣCYCCNT 
*               CM3οֲᡷ2829ҳ110125ҳ
**********************************************************/
void delay_init(uint8_t SYSCLK)
{
	CPU_CLK = (uint32_t)SYSCLK*1000*1000;	//õʱƵֵλHz

	DEM_CTRL |= 1<<24;	//λΪ1ʹܸٺ͵ģʹáϸCM3οֲᡷ115ҳ
						//ûʹøʱλʹܶԹʹõĿơܹӦóʹܣITMʹ
						//DWTܹʹ֮ǰ쳣ͼؿƼĴTRCENA(bit24)λλ

	DWT_CTRL |= 1<<0;	//ʹDWT_CYCCNT
						//ʹܣִм˲PCCYCCNTENA¼
						//ʹʱCYCCNTӦɵʼΪ0
}
/**********************************************************
*  ---> ʱnus
* ڲ ---> nusҪʱus
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void delay_us(uint32_t nus)
{
	uint32_t savecount,endcnt,CPU_cnt;

	savecount = DWT_CYCCNT;	//ǰֵ
	CPU_cnt = nus*(CPU_CLK/(1000*1000));	//ﵽʱֵCPUʱٸϵͳʱӼ
											//õȷʱʱ䣬ȥǰеʱ伴

	endcnt = savecount + CPU_cnt;	//ʱʱDWT_CYCCNTļֵʱص0

	if(endcnt > savecount)	//ʱֵڵǰֵ
	{
		while(DWT_CYCCNT < endcnt);	//ѭȴҪʱʱCPUʱӼֵ
	}
	else	//Сڵǰֵ
	{
		while(DWT_CYCCNT > endcnt);	//ȴת
		while(DWT_CYCCNT < endcnt);	//ȴʱʱ䵽
	}
}

//=========================================================
#endif
//=========================================================




















