/**********************************************************
* @ File name -> sys.h
* @ Version   -> V1.0
* @ Date      -> 12-26-2013
* @ Brief     -> ϵͳصĺͷļ
**********************************************************/

#ifndef _sys_h_
#define _sys_h_

/**********************************************************
                     ⲿͷļ                        
**********************************************************/
	
#include "stm32f10x.h"

#include "string.h"
#include "stdio.h"
//#include "alloc.h"


//0,֧ucos
//1,֧ucos
#define SYSTEM_SUPPORT_UCOS		1		//ϵͳļǷ֧UCOS

/**********************************************************
                      ̬ݱ
**********************************************************

#define MaxSize					100	//ռ

typedef uint16_t	ElemType;	//

typedef struct
{
	ElemType *elem;		//˳׵ַ
	uint16_t length;	//˳ĳȣԪصĸ
	uint16_t listsize;	//˳ռڴռĴСsizeof(ElemType)ΪλMaxSize涨
}Sqlist;
																	 */
/**********************************************************
                    JTAGģʽö
**********************************************************/

#define JTAG_SWD_Enable			0x00000000	//λֵ
#define JNTRST_Disable			0x00000001	//JNTRSTͷ
#define SWD_Enable				0x00000010	//JTAGرգSWD
#define JTAG_SWD_Disable		0x00000100	//JTAGSWDر

/**********************************************************
                    λغ궨
              οCM3Ȩָϡ87 ~ 92ҳ
**********************************************************/

#define BITBAND(addr, bitnum)			((addr & 0xF0000000)+0x2000000+((addr &0xFFFFF)<<5)+(bitnum<<2)) 
#define MEM_ADDR(addr)					*((volatile unsigned long  *)(addr)) 
#define BIT_ADDR(addr, bitnum)			MEM_ADDR(BITBAND(addr, bitnum)) 

/**********************************************************
                       GPIOַӳ
              ַϼĴƫƵַ
**********************************************************/

#define GPIOA_ODR_Addr    (GPIOA_BASE+12)	//0x4001080C 
#define GPIOB_ODR_Addr    (GPIOB_BASE+12)	//0x40010C0C 
#define GPIOC_ODR_Addr    (GPIOC_BASE+12)	//0x4001100C 
#define GPIOD_ODR_Addr    (GPIOD_BASE+12)	//0x4001140C 
#define GPIOE_ODR_Addr    (GPIOE_BASE+12)	//0x4001180C 
#define GPIOF_ODR_Addr    (GPIOF_BASE+12)	//0x40011A0C    
#define GPIOG_ODR_Addr    (GPIOG_BASE+12)	//0x40011E0C    

#define GPIOA_IDR_Addr    (GPIOA_BASE+8)	//0x40010808 
#define GPIOB_IDR_Addr    (GPIOB_BASE+8)	//0x40010C08 
#define GPIOC_IDR_Addr    (GPIOC_BASE+8)	//0x40011008 
#define GPIOD_IDR_Addr    (GPIOD_BASE+8)	//0x40011408 
#define GPIOE_IDR_Addr    (GPIOE_BASE+8)	//0x40011808 
#define GPIOF_IDR_Addr    (GPIOF_BASE+8)	//0x40011A08 
#define GPIOG_IDR_Addr    (GPIOG_BASE+8)	//0x40011E08 

/**********************************************************
             ʵֵһIO51IO
                   nֵҪСIOĿ
**********************************************************/ 

#define PAout(n)   BIT_ADDR(GPIOA_ODR_Addr,n)  // 
#define PAin(n)    BIT_ADDR(GPIOA_IDR_Addr,n)  // 

#define PBout(n)   BIT_ADDR(GPIOB_ODR_Addr,n)  // 
#define PBin(n)    BIT_ADDR(GPIOB_IDR_Addr,n)  // 

#define PCout(n)   BIT_ADDR(GPIOC_ODR_Addr,n)  // 
#define PCin(n)    BIT_ADDR(GPIOC_IDR_Addr,n)  // 

#define PDout(n)   BIT_ADDR(GPIOD_ODR_Addr,n)  // 
#define PDin(n)    BIT_ADDR(GPIOD_IDR_Addr,n)  // 

#define PEout(n)   BIT_ADDR(GPIOE_ODR_Addr,n)  // 
#define PEin(n)    BIT_ADDR(GPIOE_IDR_Addr,n)  //

#define PFout(n)   BIT_ADDR(GPIOF_ODR_Addr,n)  // 
#define PFin(n)    BIT_ADDR(GPIOF_IDR_Addr,n)  //

#define PGout(n)   BIT_ADDR(GPIOG_ODR_Addr,n)  // 
#define PGin(n)    BIT_ADDR(GPIOG_IDR_Addr,n)  //

/**********************************************************
                     ⲿùܺ
**********************************************************/

void STM32_Flash_Capacity(uint8_t *STMCapa);	//ȡоƬ

void STM32_CPUID(uint8_t *IDbuff);	//ȡCPUID

void STM_Clock_Init(uint8_t pll);	//ϵͳʱӳʼ

void MY_NVIC_SetVectorTable(uint32_t NVIC_VectTab,uint32_t Offset);	//ƫƵַ

void MY_NVIC_PriorityGroup_Config(uint32_t NVIC_PriorityGroup);	//жϷ

void MY_NVIC_Init(uint8_t NVIC_PreemptionPriority,uint8_t NVIC_Subpriority,uint8_t NVIC_Channel,uint32_t NVIC_Group);


void MY_RCC_DeInit(void);	//ʱӼĴλ

void SYS_Standby(void);	//оƬģʽ

void SYS_SoftReset(void);	//ϵͳλ

void STM_JTAG_Set(uint32_t mode);	//JTAGģʽ


uint8_t BCD_to_HEX(uint8_t BCD_Data);	//BCDתΪHEX

uint8_t HEX_to_BCD(uint8_t HEX_Data);	//HEXתΪBCD

uint16_t DX_to_HX(uint16_t DX_Data);	//10תΪ16

uint16_t HX_to_DX(uint16_t HX_Data);	//16תΪ10


//void Sqlist_Init(Sqlist *LIST);	//ʼб
//void Sqlist_DeInit(void);	//λб
//void InsertElem(Sqlist *L,uint16_t i,ElemType item);	//һ̬бһԪ

#ifndef TRUE
#define TRUE            1
#endif

#ifndef FALSE
#define FALSE           0
#endif

//typedef enum {FALSE = 0, TRUE = !FALSE} bool;

typedef u8 bool;
#define	true	TRUE
#define	false	FALSE


#endif

